function ToggleVote()
	if(ElgohVote:IsShown()) then 
		ElgohVote:Hide();
		frmMain:SetHeight(frmMain:GetHeight()-ElgohVote:GetHeight())
	else
		if(edtItem:GetText()=="") then edtItem:SetText("Item"); end
		ElgohVote:Show();
		frmMain:SetHeight(frmMain:GetHeight()+ElgohVote:GetHeight())
	end
end

function OVoteT()
	if(OElgohVote:IsShown()) then 
		OElgohVote:Hide();
		frmOfficer:SetHeight(frmOfficer:GetHeight()-OElgohVote:GetHeight())
	else
		OElgohVote:Show();
		OElgohVote:SetWidth(frmOfficer:GetWidth());
		frmOfficer:SetHeight(frmOfficer:GetHeight()+OElgohVote:GetHeight())
		if(PollTitle==nil) then
			Poll_New();
		end
	end
end

function Vote_Refresh()
	for n=1,#PollItems do
		if(VoteButtons[n]==nil) then
			VoteButtons[n]=CreateFrame("Button",nil,caMain,"UIPanelButtonTemplate")
			VoteButtons[n]:RegisterForClicks("AnyUp");
			VoteButtons[n]:SetScript("OnClick", toggle);
			if(n<6) then
				VoteButtons[n]:SetPoint("TOPLEFT", "caMain", "TOPLEFT", 15, -((n*25)));
			else
				VoteButtons[n]:SetPoint("TOPLEFT", "caMain", "TOPLEFT", 180, -(((n-5)*25)));
			end
			VoteButtons[n]:SetWidth(150)
			VoteButtons[n]:SetHeight(25)
		end
		if(GetRaidRosterInfo(n)) then
			VoteButtons[n]:SetText("|cffffffff"..raidername.." hasn't given|r");
			height=height+25;
		else
			VoteButtons[n]:Hide();
		end
	end
end

function Poll_New()
	PollItems = {};
	PollVotes = {};
	PollVoting = false;
	PollTexts={};
	PollTitle="Officer Vote:";
	edtPollTitle:SetText("Which is better?");
end

function Poll_SetItem(itemName, index)
	if (index ~= nil) then
		index = math.floor(index)
		PollItems[index] = itemName
	end

	Poll_OrderItems();
	Poll_List();
	return true
end

function Elgoh_RemoveItem(self, button)
	for index=1,#PollItems do
		if (PollItems[index] == self:GetText()) then
			frmOfficer:SetHeight(frmOfficer:GetHeight()-30);
			OElgohVote:SetHeight(OElgohVote:GetHeight()-30);
			table.remove(PollItems, index);
			self:Hide();
			Poll_OrderItems();
			return true;
		end
	end
end

function Elgoh_AddItem(item)
	if(#PollItems==5) then 
		print("Elgoh: Only 5 items may be added");
		edtItem:ClearFocus();
		return false; 
	end
	if(not item) then return false; end
	if(item=="") then return false; end
	for index=0,#PollItems do
		if (PollItems[index] == item) then
			print("Elgoh: Item already exist at "..index);
			PlaySoundFile("Sound\\interface\\Error.wav");
			edtItem:ClearFocus();
			return false;
		end
	end
	
	frmOfficer:SetHeight(frmOfficer:GetHeight()+30);
	OElgohVote:SetHeight(OElgohVote:GetHeight()+30);
	edtItem:SetText("");
	table.insert(PollItems, index)
		PollItems[#PollItems+1]=item;
	Poll_OrderItems()
	return true
end

function Elgoh_List(listing)
	local index, itemName
	if(listing==1) then
		PostTo("Elgoh: Current items in the vote:");
	end
	for index, itemName in pairs(PollItems) do
		PostTo(index..": "..itemName)
	end
	PostTo("use /vote <number> to vote or whisper me with \"!vote <number>\"");
end

function Poll_Vote(player, index)
	local indexValid, alreadyVoted

	indexValid = (index ~= nil) and (PollItems[index] ~= nil)

	alreadyVoted = (PollVotes[player] ~= nil)

	if (not indexValid or alreadyVoted) then
		--print("index ("..index..") not valid or already voted");
		return false
	end

	PollVotes[player] = {}
	PollVotes[player]["item"] = index

	local numVotes = 0
	for _, _ in pairs(PollVotes) do
		numVotes = numVotes + 1
	end

	return true
end

function Elgoh_Start()
	if (PollVoting == true) then
		print("Elgoh: Another vote is already in progress");
		return false
	end
	
	if (#PollItems < 2) then
		print("Elgoh: You need to add at least 2 items");
		return false
	end
	Hosting=true;
	PollVoteDuration = 15;
	PollVotes = {};
	OElgohVote.TimeSinceLastUpdate = 0;
	PollVoting = true;
	PostTo(edtPollTitle:GetText());
	Elgoh_List(0);
	btnElgohStart:SetText("Stop");
	SendAddonMessage("elgoh", "new", "GUILD");
end

function Elgoh_Stop()
	PollVoting = false
	Hosting=false
	
	local stuffToSay = {}
	local results = Poll_GetResults()

	if (#results == 0) then
		return
	end
	local row

	PostTo("The results are in!")
	PostTo(edtPollTitle:GetText());
	for _, row in pairs(results) do
		PostTo(row)
	end
	
	OElgohVote:SetHeight(120);
	frmOfficer:SetHeight(300);
	
	for index, itemName in pairs(PollItems) do
		if(PollTexts[index]~=nil) then
			PollTexts[index]:Hide();
		end
	end
	SendAddonMessage("elgoh", "finished", "GUILD");
	btnElgohStart:SetText("Start");
	Poll_New();
	Poll_OrderItems();
end

function Poll_GetResults()
	local itemsCount = {}
	local player, playerRow, index
	local totalCount = 0

	if (#PollItems == 0) then
		return {}
	end

	for index, _ in pairs(PollItems) do
		itemsCount[index] = {}
		itemsCount[index]['num']  = 0
		itemsCount[index]['item'] = index
	end

	for player, playerRow in pairs(PollVotes) do
		itemsCount[playerRow['item']]['num'] = itemsCount[playerRow['item']]['num'] + 1
		totalCount = totalCount + 1
	end

	table.sort(itemsCount, Poll_CompareResults)

	local resultsTable = {}
	local value
	local position = 1

	if (totalCount == 0) then
		totalCount = 1
	end

	for index, value in pairs(itemsCount) do
		table.insert(resultsTable, position..". "..
			                         PollItems[value['item']]..": ".. value['num'].." ("..math.floor(0.5 + 100 * value['num'] / totalCount).."%)")
		position = position + 1
	end

	return resultsTable
end

-- Comparison function for Poll_GetResults()
function Poll_CompareResults(rowA, rowB)
	return rowA['num'] > rowB['num']
end

function Poll_OrderItems()
	local index, itemName
	local indexes, newItemList
	newItemList = {}
	indexes = {}
	
	for index, _ in pairs(PollItems) do
		table.insert(indexes, index)
	end
	
	table.sort(indexes)
	
	for _, index in pairs(indexes) do
		newItemList[index] = PollItems[index]
	end

	PollItems = newItemList
	
	for index, itemName in pairs(PollItems) do
		if(PollTexts[index]==nil) then
			PollTexts[index]=CreateFrame("Button",nil,OElgohVote,"UIPanelButtonTemplate")
			PollTexts[index]:RegisterForClicks("AnyUp");
			PollTexts[index]:SetScript("OnClick", Elgoh_RemoveItem);
			PollTexts[index]:SetPoint("TOP", "OElgohVote", "TOP", 0, -(55+(index*25)));
			PollTexts[index]:SetWidth(150)
			PollTexts[index]:SetHeight(20)
			PollTexts[index]:Hide();
		else
			PollTexts[index]:Hide();
		end
		if(PollItems[index]) then
			PollTexts[index]:SetText(PollItems[index]);
			PollTexts[index]:Show();
		else
			PollTexts[index]:Hide();
		end
	end
end

function Poll_OnLoad()
	OElgohVote:RegisterEvent("CHAT_MSG_WHISPER")
	OElgohVote:RegisterEvent("CHAT_MSG_ADDON");
	RegisterAddonMessagePrefix("elgoh");
	OElgohVote.TimeSinceLastUpdate = 0;
	PollVoting = false;
end


function Poll_OnEvent(event, ...)
	if (event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;
		if(prefix=="elgoh") then
			if(msg=="new" and PollVoting==0) then
				PollVoting=true;
				btnElgohStart:Disable();
			elseif(msg=="finished") then
				btnElgohStart:Enable();
			elseif(msg=="1" or msg=="2" or msg=="3" or msg=="4" or msg=="5" and Hosting==true) then
				msg=tonumber(msg);
				Poll_Vote(who, msg);
				if(who~=playername) then
					SendChatMessage("Thank you for voting for \""..PollItems[msg].."\"!", "WHISPER",GetDefaultLanguage("player"), who);
				end
			end
		end
	elseif (event == "CHAT_MSG_WHISPER") then
		-- arg1: message, arg2: player
		msg,who=...;
		voting = string.find(msg, "!vote")
		if (voting ~= nil) then
			voting=string.sub(msg, voting+6)
			voting=tonumber(voting);
			Poll_Vote(who,voting);
			if(who~=playername) then
				SendChatMessage("Thank you for voting for \""..PollItems[voting].."\"!", "WHISPER",GetDefaultLanguage("player"), who);
			end
			return
		end

		Poll_Vote(arg2, arg1, false)
	end
end


function OElgohVote_OnUpdate(this, timer)
	if ((not PollVoting) or (PollVoteDuration == 0)) then return end
	
	OElgohVote.TimeSinceLastUpdate = OElgohVote.TimeSinceLastUpdate + timer
	if( OElgohVote.TimeSinceLastUpdate > PollVoteDuration ) then
		Elgoh_Stop()
	end
	if(OElgohVote.TimeSinceLastUpdate==PollVoteDuration-1) then
		PostTo("1");
	end
	if(OElgohVote.TimeSinceLastUpdate==PollVoteDuration-2) then
		PostTo("2");
	end
	if(OElgohVote.TimeSinceLastUpdate==PollVoteDuration-3) then
		PostTo("3");
	end
end